/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

/* audio cd functions */

#include <menu.h>
#include "audiocd.h"
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

int
howmanyacdtrack (char *cddevice)
{
  int cddes;
  struct disc_info abc;

  if ((cddes = cd_init_device (cddevice)) == -1)
    return 0;
  else
    {
      cd_stat (cddes, &abc);
      if (abc.disc_present != 1)
	return 0;
      else
	return abc.disc_total_tracks;
    }
}



int
playacd (int track)
{

  int cddes;
  struct disc_info abc;
  struct disc_status dstatus;
  int key = 0;
  WINDOW *statwin;
  float percent;
  int position;
  int file_ok = 1;
  //BOOL want2exit=no;
  int seconds, minutes, count;
  int totalsecsnow = 0;
  int totalsecsall = 0;
  int returncode = CONTINUE;
  time_t now;
  char timeanddate[25];
  extern LMP3GEN *playopt;

  statwin = newwin (4, 80, 20, 0);
  wbkgd (statwin, COLOR_PAIR (11));
  memset (timeanddate, 0, sizeof (char) * 25);

  if ((cddes = cd_init_device (playopt->cd_device)) == -1)
    {
      erase ();
      printw ("Error, CDROM open failed !");
      refresh ();
      napms (2000);
      file_ok = 0;
    }
  else
    {
      cd_stat (cddes, &abc);
      if (abc.disc_present != 1)
	{
	  erase ();
	  printw ("Error, no cdrom in the drive !");
	  refresh ();
	  napms (2000);
	  file_ok = 0;
	}
      else
	{
	  if (abc.disc_total_tracks < track)
	    {
	      erase ();
	      printw ("Error, no such track !");
	      refresh ();
	      napms (2000);
	      file_ok = 0;
	    }
	}
    }


  if (file_ok == 1)
    {
      nodelay (stdscr, TRUE);
      //typeahead(-1);

      // get the total time

      minutes = abc.disc_track[track - 1].track_length.minutes;
      seconds = abc.disc_track[track - 1].track_length.seconds;
      werase (statwin);
      wattron (statwin, COLOR_PAIR (11) + A_BOLD);
      box (statwin, ACS_VLINE, ACS_HLINE);
      mvwprintw (statwin, 1, 1, "[");
      mvwprintw (statwin, 1, 77, "]");
      wattron (statwin, COLOR_PAIR (8) + A_BOLD);
      mvwprintw (statwin, 2, 1, "Total : %d min %d sec", minutes, seconds);

      if (getch () == 'n')
	{
	  cd_stop (cddes);
	  return returncode;
	}
      cd_play_track (cddes, track, track);
      do
	{
	  key = getch ();
	  switch (key)
	    {

	    case 'n':
	      cd_stop (cddes);
	      break;


	    case 's':
	      cd_pause (cddes);
	      nodelay (stdscr, FALSE);
	      getch ();
	      cd_resume (cddes);
	      nodelay (stdscr, TRUE);
	      continue;

	    case 'p':
	      returncode = PREVIOUS;
	      cd_stop (cddes);
	      break;


	    case 'b':
	      returncode = RESET;
	      cd_stop (cddes);
	      break;


	    case 'q':
	      cd_stop (cddes);
	      disable_curses_and_exit (0);


	    case LEFT_KEY:
	      cd_poll (cddes, &dstatus);
	      totalsecsnow = (dstatus.status_track_time.minutes * 60)
		+ dstatus.status_track_time.seconds;
	      if (totalsecsnow - 2 > 0)
		{
		  //cd_stop(cddes);
		  cd_play_track_pos (cddes, track, track, totalsecsnow - 2);
		}
	      continue;


	    case RIGHT_KEY:
	      totalsecsall =
		abc.disc_track[track - 1].track_length.minutes * 60 +
		abc.disc_track[track - 1].track_length.seconds;
	      cd_poll (cddes, &dstatus);
	      totalsecsnow = (dstatus.status_track_time.minutes * 60)
		+ dstatus.status_track_time.seconds;
	      if (totalsecsnow + 2 <= totalsecsall)
		cd_play_track_pos (cddes, track, track, totalsecsnow + 2);
	      continue;


	    }


	  sleep (1);
	  cd_poll (cddes, &dstatus);
	  percent = (((float) (dstatus.status_track_time.minutes * 60)
		      +
		      (float) (dstatus.status_track_time.seconds))) /
	    (((float) (abc.disc_track[track - 1].track_length.minutes * 60) +
	      (float) (abc.disc_track[track - 1].track_length.seconds)));
	  //werase(statwin);
	  //wprintw(statwin,"%f",percent);
	  //wrefresh(statwin);
	  position = 75 * percent;	// there is 75 blank space in between 
	  // [ and ]

	  wattron (statwin, COLOR_PAIR (16) + A_BOLD);
	  for (count = 2; count < 77; count++)
	    mvwprintw (statwin, 1, count, " ");
	  for (count = 2; count < position + 2; count++)
	    mvwprintw (statwin, 1, count, "*");
	  minutes = dstatus.status_track_time.minutes;
	  seconds = dstatus.status_track_time.seconds;
	  wattron (statwin, COLOR_PAIR (16) + A_BOLD);
	  mvwprintw (statwin, 2, 27, "                   ");
	  mvwprintw (statwin, 2, 27, "Now : %d min %d sec", minutes, seconds);
	  time (&now);
	  strncpy (timeanddate, ctime (&now), 24);	//must do this or else will overwritten border

	  wattron (statwin, COLOR_PAIR (15) + A_BOLD);
	  mvwprintw (statwin, 2, 52, "%s", timeanddate);
	  wnoutrefresh (statwin);
	  doupdate ();
	  cd_stat (cddes, &abc);
	}
      while ((abc.disc_present == 1) && (abc.disc_mode == 0));
    }

  return returncode;
}


void
playacd_command (void)
{
  WINDOW *playwin;
  extern COM_OPT cmnd;
  extern LMP3GEN *playopt;
  int returncode;

  erase ();
  refresh ();
  playwin = newwin (20, 80, 0, 0);
  wbkgd (playwin, COLOR_PAIR (11));
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  box (playwin, ACS_VLINE, ACS_HLINE);
  wattron (playwin, COLOR_PAIR (8) + A_BOLD);
  mvwprintw (playwin, 2, 2, "Now Playing :");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  mvwprintw (playwin, 3, 4, "%d (AUDIO CD)", cmnd.acd_track);
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  mvwaddch (playwin, 5, 0, ACS_LTEE);
  mvwaddch (playwin, 5, 79, ACS_RTEE);
  wmove (playwin, 5, 1);
  whline (playwin, ACS_HLINE, 78);
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  mvwaddch (playwin, 10, 0, ACS_LTEE);
  mvwaddch (playwin, 10, 79, ACS_RTEE);
  wmove (playwin, 10, 1);
  whline (playwin, ACS_HLINE, 78);
  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  mvwprintw (playwin, 13, 4, "LOOPING : ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  if ((playopt->looping == yes) || (cmnd.looping == yes))
    wprintw (playwin, "ON");
  else
    wprintw (playwin, "OFF");
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  mvwaddch (playwin, 16, 0, ACS_LTEE);
  mvwaddch (playwin, 16, 79, ACS_RTEE);
  wmove (playwin, 16, 1);
  whline (playwin, ACS_HLINE, 78);

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  mvwprintw (playwin, 15, 2, "q: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "quit ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "s: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "pause ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "<-: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "Rewind ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "->: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "FF ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "b: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "back to beginning ");

  wattron (playwin, COLOR_PAIR (14) + A_BOLD);
  mvwprintw (playwin, 17, 2, "Lien MP3 Player Version %s  ", LMP3_VERSION);
  wprintw (playwin, "<http://lienmp3.sourceforge.net>");
  mvwprintw (playwin, 18, 2, "By Tan Chee Kien \
<gogota321@yahoo.com> under GPL License");
  wnoutrefresh (playwin);
  doupdate ();
  for (;;)
    {
      returncode = playacd (cmnd.acd_track);
      if (returncode == RESET)
	continue;
      if (cmnd.looping != yes)
	break;
    }

}
