/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

/* function that decode song using libmpeg3 */

#include <ncurses.h>
#include <libmpeg3.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
//#include "plfunc.h"
#include "lmp3.h"
//#define TRACE mvprintw(1,1,"%u  %s\n",__LINE__,__FILE__); refresh()


int
play (char *song)
{
#define insize 16384
#define outsize 65536

  mpeg3_t *file;
  int j, count;
  int key = 0;
  int result = 0;
  short audio_output_i[insize];
  short audio_output_i2[insize];
  unsigned char devbuf[outsize];
  int fd;
  int sample;
  int bits = 16;
  //  int stereo=1;
  int sr;
  int chan;
  WINDOW *statwin;
  double percent;
  int position;
  int file_ok = 1;
  double total_seconds;
  int seconds, minutes;
  extern LMP3GEN *playopt;
  extern COM_OPT cmnd;
  int returncode = CONTINUE;
  time_t now;
  char timeanddate[25];
//        long sample2;
  //        int count2;

  statwin = newwin (4, 80, 20, 0);
  wbkgd (statwin, COLOR_PAIR (11));
  if ((fd = open ("/dev/dsp", O_WRONLY)) == -1)
    {
      cur_error (unable to open / dev / dsp);
    }
  //ioctl(fd,SNDCTL_DSP_GETBLKSIZE,&size);

  if (cmnd.output_mode == stereo)
    playopt->output_mode = stereo;
  else if (cmnd.output_mode == right)
    playopt->output_mode = right;
  if (cmnd.output_mode == left)
    playopt->output_mode = left;



  if (mpeg3_check_sig (song) != 1)
    {
      erase ();
      printw ("Error, File : %s \nformat not compatible !", song);
      refresh ();
      napms (2000);
      file_ok = 0;
    }

  if (!(file = mpeg3_open (song)))
    {
      erase ();
      printw ("Error opening %s ! No such file !", file);
      refresh ();
      napms (2000);
      file_ok = 0;
    }

  if (file_ok == 1)
    {
      sr = mpeg3_sample_rate (file, 0);
      chan = mpeg3_audio_channels (file, 0);
      if (playopt->output_mode != stereo)
	chan = 1;
      if (ioctl (fd, SNDCTL_DSP_CHANNELS, &chan) == -1)
	{
	  cur_error (error setting dsp channel mode);
	}
      if (ioctl (fd, SNDCTL_DSP_SAMPLESIZE, &bits) == -1)
	{
	  cur_error (error setting sound bit to 16 bit);
	}
      if (ioctl (fd, SNDCTL_DSP_SPEED, &sr) == -1)
	{
	  cur_error (error setting dsp sampling rate);
	}
      nodelay (stdscr, TRUE);


      // get the total time
      mpeg3_seek_percentage (file, 1);
      mpeg3_read_audio (file, NULL, NULL, 0, insize, 0);
      total_seconds = mpeg3_get_time (file);
      minutes = total_seconds / 60;
      seconds = ((int) (total_seconds)) % 60;
      mpeg3_close (file);
      file = mpeg3_open (song);
      werase (statwin);
      wattron (statwin, COLOR_PAIR (11) + A_BOLD);
      box (statwin, ACS_VLINE, ACS_HLINE);
      mvwprintw (statwin, 1, 1, "[");
      mvwprintw (statwin, 1, 77, "]");
      wattron (statwin, COLOR_PAIR (8) + A_BOLD);
      mvwprintw (statwin, 2, 1, "Total : %d min %d sec", minutes, seconds);

      // Write audio
      mpeg3_set_cpus (file, 1);
      if ((chan == 2) || (playopt->output_mode == right)
	  || (playopt->output_mode == left))
	{
	  while (!mpeg3_end_of_audio (file, 0) && !result)
	    {
	      if (playopt->output_mode != right)
		{
		  result = mpeg3_read_audio (file,
					     NULL,
					     audio_output_i, 0, insize, 0);
		}

	      if ((playopt->output_mode != left)
		  && (playopt->output_mode != right))
		{
		  result = mpeg3_reread_audio (file,
					       NULL,
					       audio_output_i2, 1, insize, 0);
		}

	      if (playopt->output_mode == right)
		{
		  result = mpeg3_read_audio (file,
					     NULL,
					     audio_output_i2, 1, insize, 0);
		}

	      key = getch ();

	      if (key == 'n')
		break;


	      if (key == 's')
		{
		  nodelay (stdscr, FALSE);
		  getch ();
		  nodelay (stdscr, TRUE);
		}

	      if (key == 'p')
		{
		  returncode = PREVIOUS;
		  break;
		}

	      if (key == 'b')
		{
		  returncode = RESET;
		  break;
		}

	      if (key == 'q')
		{
		  delete_temp_file ();
		  disable_curses_and_exit (0);
		}

	      if (key == RIGHT_KEY)
		{
		  continue;
		}

	      count = 0;
	      if (playopt->output_mode == stereo)
		{
		  for (j = 0; j < insize; j = j + 1)
		    {
		      sample = (int) (audio_output_i[j]);
		      devbuf[count++] = (unsigned char) (sample & 0xff);
		      devbuf[count++] =
			(unsigned char) ((sample >> 8) & 0xff);

		      sample = (int) (audio_output_i2[j]);
		      devbuf[count++] = (unsigned char) (sample & 0xff);
		      devbuf[count++] =
			(unsigned char) ((sample >> 8) & 0xff);

		    }
		}
	      /*
	         erase();
	         mvprintw(3,2,"%ld",mpeg3_get_sample(file,0));
	         refresh(); */
	      percent = mpeg3_tell_percentage (file);
	      position = 75 * percent;	// there is 75 blank space in between 
	      // [ and ]

	      wattron (statwin, COLOR_PAIR (16) + A_BOLD);
	      for (count = 2; count < position + 2; count++)
		mvwprintw (statwin, 1, count, "*");
	      total_seconds = mpeg3_get_time (file);
	      minutes = total_seconds / 60;
	      seconds = ((int) (total_seconds)) % 60;
	      wattron (statwin, COLOR_PAIR (16) + A_BOLD);
	      mvwprintw (statwin, 2, 27, "                   ");
	      mvwprintw (statwin, 2, 27, "Now : %d min %d sec", minutes,
			 seconds);
	      time (&now);
	      strncpy (timeanddate, ctime (&now), 24);	//must do this or else will overwritten border

	      wattron (statwin, COLOR_PAIR (15) + A_BOLD);
	      mvwprintw (statwin, 2, 52, "%s", timeanddate);
	      wnoutrefresh (statwin);
	      doupdate ();
	      if (playopt->output_mode == stereo)
		write (fd, devbuf, outsize);
	      else if (playopt->output_mode == left)
		write (fd, audio_output_i, insize * 2);
	      else
		write (fd, audio_output_i2, insize * 2);

//              wmove(statwin,1,2);
	      //              wclrtoeol(statwin);
	    }
	}
      else			//Mono

	{
	  while (!mpeg3_end_of_audio (file, 0) && !result)
	    {
	      result = mpeg3_read_audio (file,
					 NULL, audio_output_i, 0, insize, 0);

	      key = getch ();

	      if (key == 'n')
		break;


	      if (key == 's')
		{
		  nodelay (stdscr, FALSE);
		  getch ();
		  nodelay (stdscr, TRUE);
		}

	      if (key == 'p')
		{
		  returncode = PREVIOUS;
		  break;
		}

	      if (key == 'b')
		{
		  returncode = RESET;
		  break;
		}

	      if (key == 'q')
		disable_curses_and_exit (0);

	      if (key == RIGHT_KEY)
		{
		  continue;
		}


	      count = 0;

	      percent = mpeg3_tell_percentage (file);
	      position = 75 * percent;	// there is 75 blank space in between 
	      // [ and ]

	      wattron (statwin, COLOR_PAIR (16) + A_BOLD);
	      for (count = 2; count < position + 2; count++)
		mvwprintw (statwin, 1, count, "*");
	      total_seconds = mpeg3_get_time (file);
	      minutes = total_seconds / 60;
	      seconds = ((int) (total_seconds)) % 60;
	      wattron (statwin, COLOR_PAIR (16) + A_BOLD);
	      mvwprintw (statwin, 2, 27, "                   ");
	      mvwprintw (statwin, 2, 27, "Now : %d min %d sec", minutes,
			 seconds);
	      time (&now);
	      strncpy (timeanddate, ctime (&now), 24);	//must do this or else will overwritten border

	      wattron (statwin, COLOR_PAIR (15) + A_BOLD);
	      mvwprintw (statwin, 2, 52, "%s", timeanddate);
	      wnoutrefresh (statwin);
	      doupdate ();
	      write (fd, audio_output_i, insize * 2);
//              wmove(statwin,1,2);
	      //              wclrtoeol(statwin);
	    }
	}
      close (fd);
      mpeg3_close (file);

    }
  else
    close (fd);

  return returncode;
}
