#ifndef MISSING_H_
#define MISSING_H_

int mpeg3_min(int x, int y);
int mpeg3_max(int x, int y);
int mpeg3bits_refill(mpeg3_bits_t* stream);
int mpeg3audio_read_ac3_header(mpeg3audio_t *audio);
int mpeg3demux_eof(mpeg3_demuxer_t *demuxer);
int mpeg3audio_read_pcm_header(mpeg3audio_t *audio);
int mpeg3demux_copy_titles(mpeg3_demuxer_t *dst, mpeg3_demuxer_t *src);
int mpeg3demux_create_title(mpeg3_demuxer_t *demuxer, 
		int timecode_search, 
		FILE *toc);
int mpeg3audio_seek_sample(mpeg3audio_t *audio, long sample);
int mpeg3audio_seek_percentage(mpeg3audio_t *audio, double percentage);
int mpeg3audio_decode_audio(mpeg3audio_t *audio, 
		float *output_f, 
		short *output_i, 
		int channel, 
		long start_position, 
		long len);
int mpeg3audio_read_raw(mpeg3audio_t *audio, unsigned char *output, 
			long *size, long max_size);
int mpeg3io_seek_relative(mpeg3_fs_t *fs, long bytes);
int mpeg3io_seek(mpeg3_fs_t *fs, long byte);
int mpeg3demux_open_title(mpeg3_demuxer_t *demuxer, int title_number);
int mpeg3_copy_title(mpeg3_title_t *dst, mpeg3_title_t *src);
int mpeg3_delete_title(mpeg3_title_t *title);
int mpeg3audio_synth_stereo(mpeg3audio_t *audio, float *bandPtr, 
			    int channel, float *out, int *pnt);
int mpeg3audio_synth_mono(mpeg3audio_t *audio, float *bandPtr, 
			  float *samples, int *pnt);
int mpeg3audio_replace_buffer(mpeg3audio_t *audio, long new_allocation);
int mpeg3bits_getbitoffset(mpeg3_bits_t *stream);
void mpeg3bits_start_reverse(mpeg3_bits_t* stream);
void mpeg3bits_start_forward(mpeg3_bits_t* stream);
int mpeg3bits_read_buffer(mpeg3_bits_t* stream, 
			  unsigned char *buffer, int bytes);
int mpeg3audio_dct36(float *inbuf, float *o1, 
		     float *o2, float *wintab, float *tsbuf);
int mpeg3audio_dct12(float *in,float *rawout1,
		     float *rawout2,register float *wi,register float *ts);
int mpeg3audio_read_header(mpeg3audio_t *audio);
int mpeg3bits_use_ptr(mpeg3_bits_t* stream, unsigned char *buffer);
int mpeg3bits_use_demuxer(mpeg3_bits_t* stream);
int mpeg3bits_delete_stream(mpeg3_bits_t* stream);
int mpeg3audio_do_ac3(mpeg3audio_t *audio);
int mpeg3audio_dolayer2(mpeg3audio_t *audio);
int mpeg3audio_dolayer3(mpeg3audio_t *audio);
int mpeg3audio_do_pcm(mpeg3audio_t *audio);
int mpeg3bits_byte_align(mpeg3_bits_t *stream);
int mpeg3bits_seek_start(mpeg3_bits_t* stream);
long mpeg3demuxer_total_bytes(mpeg3_demuxer_t *demuxer);
int mpeg3audio_reset_synths(mpeg3audio_t *audio);
int mpeg3bits_seek_time(mpeg3_bits_t* stream, double time_position);
int mpeg3bits_seek_byte(mpeg3_bits_t* stream, long position);
int mpeg3audio_prev_header(mpeg3audio_t *audio);
int mpeg3audio_read_layer3_frame(mpeg3audio_t *audio);
int mpeg3audio_new_decode_tables(mpeg3audio_t *audio);
int mpeg3bits_seek_percentage(mpeg3_bits_t* stream, double percentage);
int mpeg3audio_dct64_1(float *out0, float *out1, 
		       float *b1, float *b2, float *samples);
int mpeg3audio_imdct_init(mpeg3audio_t *audio);
int mpeg3audio_dct64(float *a, float *b, float *c);
int mpeg3_copy_fs(mpeg3_fs_t *dst, mpeg3_fs_t *src);
int mpeg3_read_next_packet(mpeg3_demuxer_t *demuxer);
int mpeg3_read_prev_packet(mpeg3_demuxer_t *demuxer);
void mpeg3io_complete_path(char *complete_path, char *path);
void mpeg3io_get_directory(char *directory, char *path);
void mpeg3io_get_filename(char *filename, char *path);
void mpeg3io_joinpath(char *title_path, char *directory, char *new_filename);
long mpeg3io_path_total_bytes(char *path);
int mpeg3demux_seek_byte(mpeg3_demuxer_t *demuxer, long byte);
int mpeg3demux_assign_programs(mpeg3_demuxer_t *demuxer);
int mpeg3demux_print_streams(mpeg3_demuxer_t *demuxer, FILE *toc);
int mpeg3demux_print_timecodes(mpeg3_title_t *title, FILE *output);
int mpeg3demux_seek_end(mpeg3_demuxer_t *demuxer);
int mpeg3demux_seek_start(mpeg3_demuxer_t *demuxer);
int mpeg3demux_seek_time(mpeg3_demuxer_t *demuxer, double new_time);
int mpeg3demux_seek_percentage(mpeg3_demuxer_t *demuxer, double percentage);
int mpeg3audio_ac3_exponent_unpack(mpeg3audio_t *audio,
		mpeg3_ac3bsi_t *bsi,
		mpeg3_ac3audblk_t *audblk);
int mpeg3audio_ac3_bit_allocate(mpeg3audio_t *audio, 
		unsigned int fscod, 
		mpeg3_ac3bsi_t *bsi, 
		mpeg3_ac3audblk_t *audblk);
int mpeg3audio_ac3_coeff_unpack(mpeg3audio_t *audio, 
	mpeg3_ac3bsi_t *bsi, 
	mpeg3_ac3audblk_t *audblk,
	mpeg3ac3_stream_samples_t samples);
int mpeg3audio_ac3_imdct(mpeg3audio_t *audio, 
		mpeg3_ac3bsi_t *bsi,
		mpeg3_ac3audblk_t *audblk, 
		mpeg3ac3_stream_samples_t samples);


#endif
