/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

/* The function that make the playlist random */

#include <ncurses.h>
#include <unistd.h>
#include "lmp3.h"
#include "plfunc.h"
#include <stdlib.h>
//#define TRACE mvprintw(1,1,"%u  %s\n",__LINE__,__FILE__); refresh()



void
makerdpl (void)
{
  unsigned totalsongs;
  extern LMP3GEN *playopt;

  int randnum, count, count2, count3;
  char dirname[MAX_LEN];
  char filename[MAX_LEN];
  //FILE *stream1, *stream2, *stream3; 
  char *temp1, *temp2, *temp3;
  int index;

  erase ();
  wbkgd (stdscr, COLOR_PAIR (7));
  attron (COLOR_PAIR (4) + A_BOLD);
  box (stdscr, '|', '-');
  move (1, 1);
  printw ("Randoming the files in playlist......");
  refresh ();

  totalsongs = playopt->totalsongs;
  temp1 = lmp3_tempnam ();
  temp2 = lmp3_tempnam ();
  temp3 = lmp3_tempnam ();


  copy_playlist_to_file (temp1, playopt->first);


  for (count = totalsongs, count2 = 1;; count--, count2++)
    {
      mvprintw (4, 4, "                           ");
      mvprintw (4, 4, "%d", count2);
      refresh ();
      randnum = giverand (count);
      randnum++;
      give_plfile_dirname (temp1, dirname, randnum);
      give_plfile_filename (temp1, filename, randnum);
      append_to_plfile (temp2, dirname, filename, count2);
      if (count2 == totalsongs)
	break;

      for (count3 = 1, index = 1; count3 <= count; count3++)
	{
	  if (count3 != randnum)
	    {
	      give_plfile_dirname (temp1, dirname, count3);
	      give_plfile_filename (temp1, filename, count3);
	      append_to_plfile (temp3, dirname, filename, index);
	      index++;
	    }
	}
      copy_file_to_file (temp1, temp3);
      unlink (temp3);
    }

  unlink (temp1);
  unlink (temp3);
  clear_playlist (playopt->first);
  copy_file_to_playlist (playopt, temp2);

  unlink (temp2);
  delete_temp_file ();
  free (temp1);
  free (temp2);
  free (temp3);

}
