/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

/* The options Menu */

#include <menu.h>
#include <pwd.h>
#include <stdlib.h>
#include <string.h>
#include "lmp3.h"
// #define TRACE mvprintw(1,1,"%u  %s\n",__LINE__,__FILE__); refresh()


#define OPTCOLOR COLOR_PAIR(26)
#define OPT2COLOR COLOR_PAIR(13)
#define MENUCOLOR COLOR_PAIR(13)

void
optmenu (void)
{
#define F10 274
#define SPACE 32



  MENU *optmenu;
  ITEM *items[10];
  WINDOW *optwin;
  WINDOW *suboptwin;
  WINDOW *optwin2;
  int key, count;
  extern LMP3GEN *playopt;
  FILE *stream;
  char conffile[50];

  erase ();
  bkgd (OPTCOLOR);
  attrset (OPTCOLOR + A_BOLD);
  mvprintw (0, 20, "OPTION MENU");
  mvprintw (3, 1, "Select option by using UP and DOWN key");
  mvprintw (4, 1, "Change it using SPACE key");
  mvprintw (5, 1, "Press F10 when finish");
  //attrset(A_NORMAL);
  refresh ();

  strncpy (conffile, playopt->conffile, 50);


//   items[0]=new_item("Quality","");
  items[0] = new_item ("Output Mode", "");
  items[1] = new_item ("Randomize", "");
  items[2] = new_item ("Looping", "");
  items[3] = NULL;
  optwin = newwin (6, 15, 10, 10);
  optwin2 = newwin (6, 15, 10, 24);
  wbkgd (optwin, OPT2COLOR);
  wbkgd (optwin2, OPT2COLOR);
  wattron (optwin, OPT2COLOR + A_BOLD);
  wattron (optwin2, OPT2COLOR + A_BOLD);
  box (optwin, ACS_VLINE, ACS_HLINE);
  box (optwin2, ACS_VLINE, ACS_HLINE);
  mvwaddch (optwin2, 0, 0, ACS_TTEE);
  mvwaddch (optwin2, 5, 0, ACS_BTEE);

  optmenu = new_menu (items);
  set_menu_mark (optmenu, "");
  suboptwin = subwin (optwin, 0, 0, 11, 11);
  set_menu_win (optmenu, suboptwin);
  set_menu_back (optmenu, COLOR_PAIR (14) + A_BOLD);

  wattron (optwin2, COLOR_PAIR (8) + A_BOLD);
  post_menu (optmenu);
  refresh ();
  /*
     switch(playopt->quality)
     {
     case 0:
     mvwprintw(optwin2,1,1,"        FULL");
     break;
     case 1: 
     mvwprintw(optwin2,1,1,"        HALF");
     break;
     case 2:
     mvwprintw(optwin2,1,1,"     QUARTER");
     break;
     } */
  switch (playopt->output_mode)
    {
    case 0:
      mvwprintw (optwin2, 1, 1, "      STEREO");
      break;
      /*  case 1: 
         mvwprintw(optwin2,1,1,"        MONO");
         break; */
    case 1:
      mvwprintw (optwin2, 1, 1, "   LEFT ONLY");
      break;
    case 2:
      mvwprintw (optwin2, 1, 1, "  RIGHT ONLY");
      break;
    }
  switch (playopt->randomize)
    {
    case 0:
      mvwprintw (optwin2, 2, 1, "          NO");
      break;
    case 1:
      mvwprintw (optwin2, 2, 1, "         YES");
      break;
    }
  switch (playopt->looping)
    {
    case 0:
      mvwprintw (optwin2, 3, 1, "          NO");
      break;
    case 1:
      mvwprintw (optwin2, 3, 1, "         YES");
      break;
    }

  wnoutrefresh (optwin);
  wnoutrefresh (optwin2);
  doupdate ();
  //wrefresh(suboptwin);
  key = 0;
  while (key != F10)
    {
      mvwaddch (optwin2, 5, 0, ACS_BTEE);
      wrefresh (optwin2);
      key = getch ();
      // move(0,0);
      //  printw("%d\n",key);
      //  refresh(); 
      switch (key)
	{

	case KEY_UP:
	  menu_driver (optmenu, REQ_UP_ITEM);
	  post_menu (optmenu);
	  wnoutrefresh (suboptwin);
	  wnoutrefresh (optwin);
	  doupdate ();
	  break;

	case KEY_DOWN:
	  menu_driver (optmenu, REQ_DOWN_ITEM);
	  post_menu (optmenu);
	  wnoutrefresh (suboptwin);
	  wnoutrefresh (optwin);
	  doupdate ();
	  break;

	case SPACE:
	  /*
	     if (strcmp(item_name(current_item(optmenu)),"Quality")==0)
	     {
	     playopt->quality++;
	     if (playopt->quality==3)
	     playopt->quality=0;
	     switch(playopt->quality)
	     {
	     case 0:
	     mvwprintw(optwin2,1,1,"        FULL");
	     break;
	     case 1: 
	     mvwprintw(optwin2,1,1,"        HALF");
	     break;
	     case 2:
	     mvwprintw(optwin2,1,1,"     QUARTER");
	     break;
	     }
	     }  */
	  if (strcmp (item_name (current_item (optmenu)), "Output Mode") == 0)
	    {
	      playopt->output_mode++;
	      if (playopt->output_mode == 3)
		playopt->output_mode = 0;
	      switch (playopt->output_mode)
		{
		case 0:
		  mvwprintw (optwin2, 1, 1, "      STEREO");
		  break;
		  /*case 1: 
		     mvwprintw(optwin2,2,1,"        MONO");
		     break; */
		case 1:
		  mvwprintw (optwin2, 1, 1, "   LEFT ONLY");
		  break;
		case 2:
		  mvwprintw (optwin2, 1, 1, "  RIGHT ONLY");
		  break;
		}
	    }
	  if (strcmp (item_name (current_item (optmenu)), "Randomize") == 0)
	    {
	      playopt->randomize++;
	      if (playopt->randomize == 2)
		playopt->randomize = 0;
	      switch (playopt->randomize)
		{
		case 0:
		  mvwprintw (optwin2, 2, 1, "          NO");
		  break;
		case 1:
		  mvwprintw (optwin2, 2, 1, "         YES");
		  break;
		}
	    }
	  if (strcmp (item_name (current_item (optmenu)), "Looping") == 0)
	    {
	      playopt->looping++;
	      if (playopt->looping == 2)
		playopt->looping = 0;
	      switch (playopt->looping)
		{
		case 0:
		  mvwprintw (optwin2, 3, 1, "          NO");
		  break;
		case 1:
		  mvwprintw (optwin2, 3, 1, "         YES");
		  break;
		}
	    }
	  wrefresh (optwin2);

	  break;
	}
    }

  if ((stream = fopen (conffile, "w")) == NULL)
    {
      erase ();
      printw ("Error writing to %s !!", conffile);
      refresh ();
      endwin ();
      exit (EXIT_FAILURE);
    }
  // fprintf(stream,"%d\n",playopt->quality);
  fprintf (stream, "%d\n", playopt->output_mode);
  fprintf (stream, "%d\n", playopt->randomize);
  fprintf (stream, "%d\n", playopt->looping);
  fclose (stream);

  free_menu (optmenu);
  for (count = 0; count < 4; count++)
    {
      free_item (items[count]);
    }
}
