/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

/* The thing you saw when the mp3 is playing */

#include "lmp3.h"
#include "audiocd.h"
#include <ncurses.h>
#include <string.h>
#include <stdlib.h>
#include "plfunc.h"

#define MP3MODE 0
#define ACDMODE 1


// limit the length so that the word won't overwrite the window
#define FILENAME_LIMIT 62
#define DIRNAME_LIMIT 71

void
playmp3 (void)
{

  WINDOW *playwin;
  char dirname[MAX_LEN];
  char filename[MAX_LEN];
  char fileplusdir[MAX_LEN * 2];
  char prefile[MAX_LEN] = "No previous file";
  const char middle[] = "/";
  int index, total, count;
  extern LMP3GEN *playopt;
  extern COM_OPT cmnd;
  int mode, cdtrack;
  char temp[100];
  int returncode;

  total = playopt->totalsongs;
  index = 0;

  for (count = total; count > 0; count--)
    {
      index++;
      erase ();
      refresh ();
      playwin = newwin (20, 80, 0, 0);
      wbkgd (playwin, COLOR_PAIR (11));

      wattron (playwin, COLOR_PAIR (11) + A_BOLD);
      box (playwin, ACS_VLINE, ACS_HLINE);
      wattron (playwin, COLOR_PAIR (8) + A_BOLD);
      mvwprintw (playwin, 2, 2, "Now Playing : ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);

      give_pl_filename (index, playopt->first, filename);

      give_pl_dirname (index, playopt->first, dirname);

      if (strcmp (dirname, "audio cd") == 0)
	mode = ACDMODE;
      else
	mode = MP3MODE;

      memset (temp, 0, 100);
      strncpy (temp, filename, FILENAME_LIMIT);
      wprintw (playwin, "%s", temp);
      if (mode == ACDMODE)
	wprintw (playwin, " (Audio CD)");

      wattron (playwin, COLOR_PAIR (8) + A_BOLD);
      mvwprintw (playwin, 3, 2, "In : ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      memset (temp, 0, 100);
      strncpy (temp, dirname, DIRNAME_LIMIT);
      wprintw (playwin, "%s", temp);

      wattron (playwin, COLOR_PAIR (11) + A_BOLD);
      mvwaddch (playwin, 5, 0, ACS_LTEE);
      mvwaddch (playwin, 5, 79, ACS_RTEE);
      wmove (playwin, 5, 1);
      whline (playwin, ACS_HLINE, 78);
      wattron (playwin, COLOR_PAIR (14) + A_BOLD);
      mvwprintw (playwin, 7, 2, "previous file:");
      wattron (playwin, COLOR_PAIR (15) + A_BOLD);
      mvwprintw (playwin, 8, 4, "%s", prefile);

      strncpy (prefile, filename, 100);

      wattron (playwin, COLOR_PAIR (11) + A_BOLD);
      mvwaddch (playwin, 10, 0, ACS_LTEE);
      mvwaddch (playwin, 10, 79, ACS_RTEE);
      wmove (playwin, 10, 1);
      whline (playwin, ACS_HLINE, 78);
      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      mvwprintw (playwin, 12, 4, "Playing ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "%d ", index);
      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "of ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "%d ", total);
      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "files");
      mvwprintw (playwin, 13, 4, "LOOPING : ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      if ((playopt->looping == yes) || (cmnd.looping == yes))
	wprintw (playwin, "ON");
      else
	wprintw (playwin, "OFF");
      wattron (playwin, COLOR_PAIR (11) + A_BOLD);
      mvwaddch (playwin, 16, 0, ACS_LTEE);
      mvwaddch (playwin, 16, 79, ACS_RTEE);
      wmove (playwin, 16, 1);
      whline (playwin, ACS_HLINE, 78);

      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      mvwprintw (playwin, 15, 2, "q: ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "quit ");

      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "n: ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "next ");

      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "s: ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "pause ");

      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "p: ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "previous ");

      if (mode == ACDMODE)
	{
	  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
	  wprintw (playwin, "<-: ");
	  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
	  wprintw (playwin, "Rewind ");
	}

      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "->: ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "FF ");

      wattron (playwin, COLOR_PAIR (13) + A_BOLD);
      wprintw (playwin, "b: ");
      wattron (playwin, COLOR_PAIR (16) + A_BOLD);
      wprintw (playwin, "back to beginning ");

      wattron (playwin, COLOR_PAIR (14) + A_BOLD);
      mvwprintw (playwin, 17, 2, "Lien MP3 Player Version %s  ",
		 LMP3_VERSION);
      wprintw (playwin, "<http://lienmp3.sourceforge.net>");
      mvwprintw (playwin, 18, 2, "By Tan Chee Kien \
<gogota321@yahoo.com> Under GPL License");
      /* mvwprintw(playwin,19,2,"Comes with ABSOLUTELY NO WARRANTY, \
         Distributed under GPL License"); */
      wnoutrefresh (playwin);
      doupdate ();
//     move(21,0);
      napms (500);

      if (mode == MP3MODE)
	{
	  strcpy (fileplusdir, dirname);
	  if (strcmp (dirname, "/") != 0)
	    strcat (fileplusdir, middle);
	  strcat (fileplusdir, filename);

	  returncode = play (fileplusdir);
	  if (returncode == CONTINUE)
	    continue;
	  else if (returncode == PREVIOUS)
	    {
	      if (index != 1)	//u can't rewind the first song man ! no previous song

		{
		  index -= 2;
		  count += 2;
		}
	      else
		{
		  index--;
		  count--;
		}
	    }
	  else			// returncode == RESET

	    {
	      if (index != 1)
		{
		  index--;
		  count++;
		}
	      else
		{
		  index--;
		  count--;
		}
	    }
	}
      else			// audio cd

	{
	  cdtrack = atoi (filename);
	  returncode = playacd (cdtrack);
	  if (returncode == CONTINUE)
	    continue;
	  else if (returncode == PREVIOUS)
	    {
	      if (index != 1)	//u can't rewind the first song man ! no previous song

		{
		  index -= 2;
		  count += 2;
		}
	      else
		{
		  index--;
		  count--;
		}
	    }
	  else			// returncode == RESET

	    {
	      if (index != 1)
		{
		  index--;
		  count++;
		}
	      else
		{
		  index--;
		  count--;
		}
	    }
	}
    }
}

void
playmp3_command (void)
{
  WINDOW *playwin;
  extern COM_OPT cmnd;
  extern LMP3GEN *playopt;
  int returncode;

  erase ();
  refresh ();
  playwin = newwin (20, 80, 0, 0);
  wbkgd (playwin, COLOR_PAIR (11));
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  box (playwin, ACS_VLINE, ACS_HLINE);
  wattron (playwin, COLOR_PAIR (8) + A_BOLD);
  mvwprintw (playwin, 2, 2, "Now Playing :");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  mvwprintw (playwin, 3, 4, "%s", cmnd.mp3file);
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  mvwaddch (playwin, 5, 0, ACS_LTEE);
  mvwaddch (playwin, 5, 79, ACS_RTEE);
  wmove (playwin, 5, 1);
  whline (playwin, ACS_HLINE, 78);
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  mvwaddch (playwin, 10, 0, ACS_LTEE);
  mvwaddch (playwin, 10, 79, ACS_RTEE);
  wmove (playwin, 10, 1);
  whline (playwin, ACS_HLINE, 78);
  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  mvwprintw (playwin, 13, 4, "LOOPING : ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  if ((playopt->looping == yes) || (cmnd.looping == yes))
    wprintw (playwin, "ON");
  else
    wprintw (playwin, "OFF");
  wattron (playwin, COLOR_PAIR (11) + A_BOLD);
  mvwaddch (playwin, 16, 0, ACS_LTEE);
  mvwaddch (playwin, 16, 79, ACS_RTEE);
  wmove (playwin, 16, 1);
  whline (playwin, ACS_HLINE, 78);

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  mvwprintw (playwin, 15, 2, "q: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "quit ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "s: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "pause ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "->: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "FF ");

  wattron (playwin, COLOR_PAIR (13) + A_BOLD);
  wprintw (playwin, "b: ");
  wattron (playwin, COLOR_PAIR (16) + A_BOLD);
  wprintw (playwin, "back to beginning ");

  wattron (playwin, COLOR_PAIR (14) + A_BOLD);
  mvwprintw (playwin, 17, 2, "Lien MP3 Player Version %s  ", LMP3_VERSION);
  wprintw (playwin, "<http://lienmp3.sourceforge.net>");
  mvwprintw (playwin, 18, 2, "By Tan Chee Kien \
<gogota321@yahoo.com> under GPL License");
  wnoutrefresh (playwin);
  doupdate ();
  for (;;)
    {
      returncode = play (cmnd.mp3file);
      if (returncode == RESET)
	continue;
      if (cmnd.looping != yes)
	break;
    }

}
