/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/


/* Various Playlist function */

#include "lmp3.h"
#include "plfunc.h"
#include <stdlib.h>
#include <string.h>
#include <ncurses.h>

/*
   void copy_playlist(PLAYBACK *dest, const PLAYBACK * const src)
   {
   PLAYLIST *a, *b;
   dest->randomize=src->randomize;
   dest->looping=src->looping;
   dest->totalsongs=src->totalsongs;
   dest->output_mode=src->output_mode;
   strncpy(dest->conffile,src->conffile,MAX_LEN-1);
   a=src->first;


   while(TRUE)
   { 
   if(a->songnum==1)
   {
   b=(PLAYLIST *)malloc(sizeof(PLAYLIST));
   memcheck(b);
   dest->first=b;
   }
   strncpy(b->dirname,a->dirname,MAX_LEN-1);
   strncpy(b->filename,a->filename,MAX_LEN-1);
   b->songnum=a->songnum;

   if (a->next==NULL)
   {
   dest->last=b;
   b->next=NULL;
   break;
   }
   else
   {
   b->next=(PLAYLIST *)malloc(sizeof(PLAYLIST));
   memcheck(b);
   }
   b=b->next;
   a=a->next;
   }

   } */

void
give_pl_dirname (const int item_num, const PLAYLIST * const a,
		 char *const temp)
{
  if (a->songnum != item_num)
    give_pl_dirname (item_num, a->next, temp);
  else
    strncpy (temp, a->dirname, MAX_LEN - 1);
}

void
give_pl_filename (const int item_num, const PLAYLIST * const a,
		  char *const temp)
{
  if (a->songnum != item_num)
    give_pl_filename (item_num, a->next, temp);
  else
    strncpy (temp, a->filename, MAX_LEN - 1);
}

/*
   void append_to_playlist(PLAYBACK *dest, PLAYBACK *src,
   char const * const dirname, 
   const char * const filename)
   {
   PLAYLIST *a;
   int temp;

   if (dest->totalsongs==0) //dest is blank
   {
   dest->randomize=src->randomize;
   dest->looping=src->looping;
   dest->totalsongs=1;
   dest->output_mode=src->output_mode;
   strncpy(dest->conffile,src->conffile,MAX_LEN-1);

   dest->first=(PLAYLIST *)malloc(sizeof(PLAYLIST));
   memcheck(dest->first);
   a=dest->first;
   strncpy(a->dirname,dirname,MAX_LEN-1);
   strncpy(a->filename,filename,MAX_LEN-1);
   a->songnum=1;
   a->next=NULL;
   dest->last=a;
   }
   else
   {
   a=dest->last;
   temp=dest->last->songnum;
   a->next=(PLAYLIST *)malloc(sizeof(PLAYLIST));
   memcheck(a->next);
   a=a->next;
   strncpy(a->dirname,dirname,MAX_LEN-1);
   strncpy(a->filename,filename,MAX_LEN-1);
   a->songnum=temp+1;
   a->next=NULL;
   dest->last=a;
   (dest->totalsongs)++;
   }
   }
 */
void
clear_playlist (PLAYLIST * a)
{
  PLAYLIST *temp;
  if (a != NULL)
    {
      temp = a->next;
      free (a);
      a = NULL;
      clear_playlist (temp);
    }
}

void
print_playlist (const PLAYLIST * const a)
{
  erase ();
  printw ("%s, \n", a->dirname);
  printw ("%s, \n", a->filename);
  printw ("%d", a->songnum);
  refresh ();
  getch ();
  if (a->next != NULL)
    print_playlist (a->next);
}

void
copy_playlist_to_file (const char *const filename, PLAYLIST * a)
{
  FILE *stream;

  stream = fopen (filename, "a");
  fprintf (stream, "%d\n", a->songnum);
  fprintf (stream, "%s\n", a->dirname);
  fprintf (stream, "%s\n", a->filename);
  fclose (stream);
  if (a->next != NULL)
    copy_playlist_to_file (filename, a->next);
}

void
give_plfile_dirname (const char *const filename, char *const dirname,
		     const int itemnum)
{
  FILE *stream;
  char temp1[MAX_LEN], temp3[10];
  char temp2[MAX_LEN];

  sprintf (temp3, "%d", itemnum);
  stream = fopen (filename, "r");
  do
    {
      fscanf (stream, "%[^\n]", temp1);
      fscanf (stream, "%[\n]", temp2);
      fscanf (stream, "%[^\n]", dirname);
      fscanf (stream, "%[\n]", temp2);
      fscanf (stream, "%[^\n]", temp2);
      fscanf (stream, "%[\n]", temp2);
    }
  while (strcmp (temp1, temp3) != 0);
  fclose (stream);
}

void
give_plfile_filename (const char *const filename, char *const fname,
		      const int itemnum)
{
  FILE *stream;
  char temp1[MAX_LEN], temp2[MAX_LEN], temp3[10];

  sprintf (temp3, "%d", itemnum);
  stream = fopen (filename, "r");
  do
    {
      fscanf (stream, "%[^\n]", temp1);
      fscanf (stream, "%[\n]", temp2);
      fscanf (stream, "%[^\n]", temp2);
      fscanf (stream, "%[\n]", temp2);
      fscanf (stream, "%[^\n]", fname);
      fscanf (stream, "%[\n]", temp2);
    }
  while (strcmp (temp1, temp3) != 0);
  fclose (stream);
}

void
append_to_plfile (const char *const filename, const char *dirname,
		  const char *const fname, const int itemnum)
{
  FILE *stream;

  stream = fopen (filename, "a");
  fprintf (stream, "%d\n", itemnum);
  fprintf (stream, "%s\n", dirname);
  fprintf (stream, "%s\n", fname);
  fclose (stream);
}

void
copy_file_to_file (const char *destfile, const char *srcfile)
{
  FILE *stream1, *stream2;
  int a;

  stream1 = fopen (srcfile, "r");
  stream2 = fopen (destfile, "w");

  while (feof (stream1) == 0)
    {
      a = fgetc (stream1);
      if (a != EOF)
	fputc (a, stream2);
    }
  fclose (stream1);
  fclose (stream2);
}

void
copy_file_to_playlist (LMP3GEN * b, const char *fname)
{
  FILE *stream;
  char temp[MAX_LEN];
  PLAYLIST *temp2 = 0;
  int c = 0;
  PLAYLIST *a;

  b->first = (PLAYLIST *) malloc (sizeof (PLAYLIST));
  a = b->first;

  stream = fopen (fname, "r");

  while (feof (stream) == 0)
    {
      fscanf (stream, "%[^\n]", temp);
      c = atoi (temp);
      a->songnum = c;
      fscanf (stream, "%[\n]", temp);
      fscanf (stream, "%[^\n]", a->dirname);
      fscanf (stream, "%[\n]", temp);
      fscanf (stream, "%[^\n]", a->filename);
      fscanf (stream, "%[\n]", temp);
      temp2 = a;
      a->next = (PLAYLIST *) malloc (sizeof (PLAYLIST));
      a = a->next;
    }
  b->last = temp2;
  free (a);
  a = NULL;
  temp2->next = NULL;
  b->totalsongs = c;
  fclose (stream);
}
