/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/

/* header file for plfunc.c */

#ifndef _PLFUNC_H
#define _PLFUNC_H

// recursively print playlist, for debugging only
void print_playlist (const PLAYLIST * const a);

//recursively clear the memory taken by the linked list
void clear_playlist (PLAYLIST * a);

//recursively copy playlist item to file
void copy_playlist_to_file (const char *const filename, PLAYLIST * a);

void give_plfile_dirname (const char *const filename, char *const dirname,
			  const int itemnum);

void give_plfile_filename (const char *const filename, char *const fname,
			   const int itemnum);

// append itemnum, dirname, fname to end of file
void append_to_plfile (const char *const filename, const char *dirname,
		       const char *const fname, const int itemnum);

// warning : text file only !!!!!!!!!
void copy_file_to_file (const char *destfile, const char *srcfile);

// be sure to empty b first !
void copy_file_to_playlist (LMP3GEN * b, const char *fname);

void give_pl_dirname (const int item_num, const PLAYLIST * const a,
		      char *const temp);

void give_pl_filename (const int item_num, const PLAYLIST * const a,
		       char *const temp);


#endif
