/*****************************************************************************
* Lien Mp3 Player is an audio CD and mp3 player for GNU/Linux                *
* Copyright (C) 2007 Tan Chee Kien. See file COPYING for licence details     *
*                                                                            *
*    This program is free software; you can redistribute it and/or modify    *
*    it under the terms of the GNU General Public License as published by    *
*    the Free Software Foundation; either version 2 of the License, or       *
*    any later version.                                                      *
*                                                                            *
*    This program is distributed in the hope that it will be useful,         *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*    GNU General Public License for more details.                            *
*                                                                            *
*    You should have received a copy of the GNU General Public License       *
*    along with this program; if not, write to the Free Software             *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307    *  
*    USA                                                                     *
*                                                                            *
*    You can contact the author by sending an email to :                     *
*       gogota321@yahoo.com                                                  *
*****************************************************************************/


/* The playlist menu */

//#define TRACE mvprintw(1,1,"%u  %s\n",__LINE__,__FILE__); refresh()

#include <menu.h>
#include "lmp3.h"
#include "plfunc.h"
#include <stdlib.h>
#include <string.h>

#define MAX_CHAR 75		//maximum filename length that can display on screen
		     //for menuitem
#define PLCOLOR COLOR_PAIR(11)

void
plmenu (int *reload)
{

#define HOME 262
#define END 360
#define F10 274
#define F1 265
#define F2 266
#define F3 267
#define DEL 330

  extern LMP3GEN *playopt;
  ITEM *item[(playopt->totalsongs) + 1];
  WINDOW *plwin, *subplwin, *titlewin, *howtowin;
  MENU *songmenu;
  int key = 0, count2, count, w2quit = no;
  int ttldelfile = 0, loadplsuccess = 0;
  int delfileindex[playopt->totalsongs], delthesong = 0;

  FILE *stream, *newpl;
  char *filename, *index, temp[MAX_LEN], savename[50];
  //char *temp2, *newplaylist;
  char line1[10], line2[MAX_LEN], line3[MAX_LEN];	//for transfering playlist file 

  int menu_max_item;

  erase ();
  refresh ();

  titlewin = newwin (3, 80, 0, 0);
  wbkgd (titlewin, COLOR_PAIR (20));
  wattron (titlewin, COLOR_PAIR (20) + A_BOLD);
  mvwprintw (titlewin, 0, 30, "Playlist menu");
  mvwprintw (titlewin, 2, 0, "F1/o : Open Playlist");
  mvwprintw (titlewin, 2, 22, "F2/s : Save Current Playlist");
  mvwprintw (titlewin, 2, 52, "F10 : Exit from this menu");
  wnoutrefresh (titlewin);

  howtowin = newwin (3, 80, 3, 0);
  wbkgd (howtowin, COLOR_PAIR (20));
  wattron (howtowin, COLOR_PAIR (20) + A_BOLD);
  mvwprintw (howtowin, 0, 0,
	     "Use SPACE to select songs to remove, then press DEL");
  mvwprintw (howtowin, 1, 0, "Press F3/a will remove all");
  wnoutrefresh (howtowin);


  plwin = newwin (18, 80, 6, 0);
  wbkgd (plwin, PLCOLOR);
  wattrset (plwin, PLCOLOR + A_BOLD);
  box (plwin, ACS_VLINE, ACS_HLINE);
  wnoutrefresh (plwin);
  subplwin = subwin (plwin, 16, 78, 7, 1);
  //wbkgd(subplwin,COLOR_PAIR(11));


  if (playopt->totalsongs != 0)
    {
      playopt->plfile = lmp3_tempnam ();
      playopt->tempfile1 = lmp3_tempnam ();
      playopt->tempfile2 = lmp3_tempnam ();
      copy_playlist_to_file (playopt->plfile, playopt->first);
      count2 = 0;

      for (count = 1; count <= playopt->totalsongs; count++)
	{
	  filename = (char *) malloc (sizeof (char) * MAX_CHAR);
	  memcheck (filename);
	  memset (filename, 0, MAX_CHAR);
	  index = (char *) malloc (sizeof (char) * 10);
	  memcheck (index);
	  sprintf (index, "%d", count);
	  give_plfile_filename (playopt->plfile, temp, count);
	  strncpy (filename, temp, MAX_CHAR - 1);
	  item[count2] = new_item (index, filename);
	  count2++;
	}
      item[count2] = NULL;
      menu_max_item = count2;

      songmenu = new_menu (item);
      set_menu_win (songmenu, subplwin);
      set_menu_mark (songmenu, "");
      set_menu_format (songmenu, 16, 1);
      set_menu_fore (songmenu, COLOR_PAIR (17) + A_BOLD);
      set_menu_back (songmenu, COLOR_PAIR (13) + A_BOLD);
      set_menu_grey (songmenu, COLOR_PAIR (8));
      post_menu (songmenu);
      wnoutrefresh (subplwin);
      wnoutrefresh (plwin);
      doupdate ();
      while (w2quit == no)
	{
	  key = getch ();
//                  mvprintw(0,0,"%d",key);
	  switch (key)
	    {
	    case KEY_UP:
	      werase (subplwin);
	      if (menu_driver (songmenu, REQ_UP_ITEM) == E_OK)
		{
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		}
	      break;

	    case KEY_DOWN:
	      werase (subplwin);
	      if (menu_driver (songmenu, REQ_DOWN_ITEM) == E_OK)
		{
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		}
	      break;

	    case KEY_NPAGE:
	      werase (subplwin);
	      if (menu_driver (songmenu, REQ_SCR_DPAGE) == E_OK)
		{
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		}
	      break;

	    case KEY_PPAGE:
	      werase (subplwin);
	      if (menu_driver (songmenu, REQ_SCR_UPAGE) == E_OK)
		{
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		}
	      break;

	    case HOME:
	      werase (subplwin);
	      if (menu_driver (songmenu, REQ_FIRST_ITEM) == E_OK)
		{
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		}
	      break;

	    case END:
	      werase (subplwin);
	      if (menu_driver (songmenu, REQ_LAST_ITEM) == E_OK)
		{
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		}
	      break;


	    case F2:
	    case 's':
	      werase (subplwin);
	      mvwprintw (subplwin, 0, 0,
			 "Please type the directory and name to save ");
	      mvwprintw (subplwin, 1, 0,
			 "Example : /home/pikachu/myplaylist");
	      wmove (subplwin, 3, 0);
	      wrefresh (subplwin);
	      echo ();
	      for (count = 0; count <= 20; count++)
		savename[count] = '\0';
	      wgetnstr (subplwin, savename, 49);
	      noecho ();
	      if ((stream = fopen (savename, "r")) != NULL)
		{
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(5)+A_BOLD);
		  mvwprintw (subplwin, 1, 1, "File already exist !!");
		  mvwprintw (subplwin, 2, 1, "delete it and try again.");
		  wmove (subplwin, 3, 1);
		  wrefresh (subplwin);
		  fclose (stream);
		  getch ();
		  w2quit = yes;
		  break;
		}
	      if ((stream = fopen (savename, "w")) == NULL)
		{
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(5)+A_BOLD);
		  mvwprintw (subplwin, 1, 1,
			     "Cannot write to the file you specify !");
		  mvwprintw (subplwin, 2, 1,
			     "Maybe you don't have write permission there or invalid directory name !");
		  wmove (subplwin, 3, 1);
		  wrefresh (subplwin);
		  getch ();
		  w2quit = yes;
		  break;
		}
	      else
		{
		  fclose (stream);
		  copy_file_to_file (savename, playopt->plfile);
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(1)+A_BOLD);
		  mvwprintw (subplwin, 1, 1, "Save to %s", savename);
		  wmove (subplwin, 2, 1);
		  wrefresh (subplwin);
		  getch ();
		}
	      werase (subplwin);
	      //w2quit=yes;
	      continue;

	    case F1:
	    case 'o':
	      werase (subplwin);
	      mvwprintw (subplwin, 0, 0,
			 "Please type the directory and name of your playlist file ");
	      mvwprintw (subplwin, 1, 0,
			 "Example : /home/pikachu/myplaylist");
	      wmove (subplwin, 3, 0);
	      wrefresh (subplwin);
	      echo ();
	      wgetnstr (subplwin, savename, 49);
	      noecho ();

	      if ((stream = fopen (savename, "r")) == NULL)
		{
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(5)+A_BOLD);
		  mvwprintw (subplwin, 1, 1,
			     "Cannot read from the file you specify !");
		  mvwprintw (subplwin, 2, 1,
			     "Maybe you don't have read permission there or invalid directory name !");
		  wmove (subplwin, 3, 1);
		  wrefresh (subplwin);
		  getch ();
		}
	      else
		{
		  fclose (stream);
		  copy_file_to_file (playopt->plfile, savename);
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(1)+A_BOLD);
		  mvwprintw (subplwin, 1, 1, "Loading %s success", savename);
		  wmove (subplwin, 2, 1);
		  wrefresh (subplwin);
		  getch ();
		  w2quit = yes;
		}
	      break;

	    case F10:
	      w2quit = yes;
	      break;

	    case ' ':
	      werase (subplwin);
	      if (item_opts (current_item (songmenu)) == O_SELECTABLE)
		{
		  stream = fopen (playopt->tempfile1, "a");
		  item_opts_off (current_item (songmenu), O_SELECTABLE);
		  fprintf (stream, "%s\n",
			   item_name (current_item (songmenu)));
		  fclose (stream);
		  post_menu (songmenu);
		  wnoutrefresh (subplwin);
		  doupdate ();
		  ttldelfile++;
		}
	      break;

	    case F3:
	    case 'a':
	      werase (subplwin);
	      menu_driver (songmenu, REQ_FIRST_ITEM);
	      remove (playopt->tempfile1);
	      do
		{
		  ttldelfile++;
		}
	      while (menu_driver (songmenu, REQ_DOWN_ITEM) == E_OK);
	      w2quit = yes;
	      break;

	    case DEL:
	      if ((stream = fopen (playopt->tempfile1, "r")) != NULL)
		{
		  count = 1;

		  for (count2 = 0; feof (stream) == 0; count2++)
		    {
		      fscanf (stream, "%[^\n]", temp);
		      delfileindex[count2] = atoi (temp);
		      fscanf (stream, "%[\n]", temp);
		      // ?? count2++;
		    }
		  delfileindex[count2] = 0;
		  fclose (stream);

		  //for(count2=0;count2!=0;count2++)
		  //{
		  //       mvprintw(count2,0,"%d",delfileindex[count2]);
		  //       refresh();
		  //    }
		  //  getch();

		  playopt->tempfile2 = lmp3_tempnam ();
		  stream = fopen (playopt->plfile, "r");
		  newpl = fopen (playopt->tempfile2, "w");



		  while (feof (stream) == 0)
		    {
		      fscanf (stream, "%[^\n]", line1);
		      fscanf (stream, "%[\n]", temp);
		      fscanf (stream, "%[^\n]", line2);
		      fscanf (stream, "%[\n]", temp);
		      fscanf (stream, "%[^\n]", line3);
		      fscanf (stream, "%[\n]", temp);
		      fscanf (stream, "%[\n]", temp);
		      for (count2 = 0; delfileindex[count2] != 0; count2++)
			{
			  if (delfileindex[count2] == atoi (line1))
			    {
			      delthesong = yes;
			      break;
			    }
			  else
			    delthesong = no;
			}
		      if (delthesong == no)
			{
			  fprintf (newpl, "%d\n", count);
			  count++;
			  fprintf (newpl, "%s\n", line2);
			  fprintf (newpl, "%s\n", line3);
			}

		    }


		  fclose (newpl);
		  fclose (stream);
		  copy_file_to_file (playopt->plfile, playopt->tempfile2);
		  remove (playopt->tempfile2);
		  *reload = yes;
		}
	      w2quit = yes;
	      break;

	    default:
	      break;
	    }
	}
      for (count = 0; count < menu_max_item; count++)
	{
	  free_item (item[count]);
	}
      free_menu (songmenu);
    }

  else				//this one will run if user doesn't select any file before enter plmenu

    {
      playopt->plfile = lmp3_tempnam ();
      doupdate ();

      while (w2quit == no)
	{
	  key = getch ();
	  switch (key)
	    {
	    case F1:
	      werase (subplwin);
	      mvwprintw (subplwin, 0, 0,
			 "Please type the directory and name of your playlist file ");
	      mvwprintw (subplwin, 1, 0,
			 "Example : /home/pikachu/myplaylist");
	      wmove (subplwin, 3, 0);
	      wrefresh (subplwin);
	      echo ();
	      wgetnstr (subplwin, savename, 49);
	      noecho ();

	      if ((stream = fopen (savename, "r")) == NULL)
		{
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(5)+A_BOLD);
		  mvwprintw (subplwin, 1, 1,
			     "Cannot read from the file you specify !");
		  mvwprintw (subplwin, 2, 1,
			     "Maybe you don't have read permission there or invalid directory name !");
		  wmove (subplwin, 3, 1);
		  wrefresh (subplwin);
		  getch ();
		  w2quit = yes;
		}
	      else
		{
		  fclose (stream);
		  copy_file_to_file (playopt->plfile, savename);
		  werase (subplwin);
		  //wattrset(subplwin,COLOR_PAIR(1)+A_BOLD);
		  mvwprintw (subplwin, 1, 1, "Loading %s success", savename);
		  wmove (subplwin, 2, 1);
		  wrefresh (subplwin);
		  getch ();
		  loadplsuccess = yes;
		  w2quit = yes;
		}
	      break;

	    case F10:
	      w2quit = yes;
	      break;

	    default:
	      break;

	    }
	}
    }
  if (playopt->tempfile1 != NULL)
    remove (playopt->tempfile1);

  if ((ttldelfile < playopt->totalsongs) || (loadplsuccess == yes))
    {
      blank_lmp3gen (playopt);
      copy_file_to_playlist (playopt, playopt->plfile);
    }
  else
    blank_lmp3gen (playopt);

  remove (playopt->plfile);

}
